---
title: DOMTokenList.replace()
slug: Web/API/DOMTokenList/replace
tags:
  - API
  - DOM
  - Document
  - Method
  - Reference
---
<p>{{APIRef("DOM")}}</p>

<p>The <code><strong>replace()</strong></code> method of the {{domxref("DOMTokenList")}} interface replaces an existing token with a new token. If the first token doesn't exist, <code>replace()</code> returns <code>false</code> immediately, without adding the new token to the token list.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>tokenList</var>.replace(<var>oldToken</var>, <var>newToken</var>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>oldToken</var></code></dt>
 <dd>A {{domxref("DOMString")}} representing the token you want to replace.</dd>
 <dt><code><var>newToken</var></code></dt>
 <dd>A {{domxref("DOMString")}} representing the token you want to replace <code><var>oldToken</var></code> with.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A boolean value, which is <code>true</code> if <code><var>oldToken</var></code> was successfully replaced, or <code>false</code> if not.</p>

<div class="note">
<p><strong>Note</strong>: In older browsers, <code>replace()</code> returns void.</p>
</div>

<h2 id="Examples">Examples</h2>

<p>In the following example we retrieve the list of classes set on a {{htmlelement("span")}} element as a <code>DOMTokenList</code> using {{domxref("Element.classList")}}. We then replace a token in the list, and write the list into the <code>&lt;span&gt;</code>'s {{domxref("Node.textContent")}}.</p>

<p>First, the HTML:</p>

<pre class="brush: html notranslate">&lt;span class="a b c"&gt;&lt;/span&gt;</pre>

<p>Now the JavaScript:</p>

<pre class="brush: js notranslate">let span = document.querySelector("span");
let classes = span.classList;

let result = classes.replace("c", "z");
console.log(result);

if (result) {
  span.textContent = classes;
} else {
  span.textContent = 'token not replaced successfully';
}</pre>

<p>The output looks like this:</p>

<p>{{ EmbedLiveSample('Examples', '100%', 60) }}</p>

<h2 id="Polyfill">Polyfill</h2>

<p>The following polyfill will add the replace method to the <code>DOMTokenList</code> class.  The following code will only work with <strong>IE10-11</strong>. To use with earlier versions of IE, refer to the polyfill at {{domxref("element.classList#Polyfill")}}</p>

<pre class="brush: js notranslate"><code>DOMTokenList.prototype.replace = function (a, b) {
    if (this.contains(a)) {
        this.add(b);
        this.remove(a);
        return true;
    }
    return false;
}</code></pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('DOM WHATWG','#dom-domtokenlist-replace','replace()')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.DOMTokenList.replace")}}</p>
</div>
